$read_bit = $bit_count = $valid = $prev_start = $sent_byte = $read_byte = $read_allowed = 0;

while (<>) {
    chomp;
    if (/^GET\s+([01])\s*$/) {
	$read_bit = $1;
	next;
    }
    elsif (not /^SET\s+([01])\s+([01])\s*$/) {
	print $_, "\n";
	next;
    }
    unshift @SCL, $1;
    if (scalar(@SCL) > 5) {
	pop @SCL;
    }
    unshift @SDA, $2;
    if (scalar(@SDA) > 5) {
	pop @SDA;
    }
    if ($SCL[0] == "0" && $SDA[0] == "0" &&
	$SCL[1] == "1" && $SDA[1] == "0" &&
	$SCL[2] == "1" && $SDA[2] == "1" &&
	$SCL[3] == "0" && $SDA[3] == "1") {
	die "Bad Start at $.\n" if $bit_count || $valid;
	print "Start\n";
	$valid = 1;
	$prev_start = 1;
    }
    elsif ($SCL[0] == "1" && $SDA[0] == "1" &&
	   $SCL[1] == "1" && $SDA[1] == "0" &&
	   $SCL[2] == "0" && $SDA[2] == "0") {
	die "Bad Stop at $.\n" if $bit_count || !$valid || $prev_start;
	print "Stop\n";
	$valid = 0;
    }
    elsif ($SCL[0] == "0" && $SDA[0] == "1" &&
	   $SCL[1] == "1" && $SDA[1] == "1" &&
	   $SCL[2] == "0" && $SDA[2] == "1") {
	die "Bad One at $.\n" if !$valid;
	$bit_count++;
	if ($bit_count == 8 && $prev_start) {
	    $read_allowed = 1;
	    $prev_start = 0;
	}
	if ($bit_count == 9) {
	    if ($read_allowed && $sent_byte == 0xFF) {
		printf "Read byte 0x%02x\n", $read_byte;
	    }
	    else {
		printf "Sent byte 0x%02x\n", $sent_byte;
	    }
	    $bit_count = $sent_byte = $read_byte = 0;
	}
	else {
	    $sent_byte = ($sent_byte << 1) | 1;
	    $read_byte = ($read_byte << 1) | $read_bit;
	}
    }
    elsif ($SCL[0] == "0" && $SDA[0] == "0" &&
	   $SCL[1] == "1" && $SDA[1] == "0" &&
	   $SCL[2] == "0" && $SDA[2] == "0") {
	die "Bad Zero at $.\n" if !$valid;
	$bit_count++;
	if ($bit_count == 8 && $prev_start) {
	    $read_allowed = 0;
	    $prev_start = 0;
	}
	if ($bit_count == 9) {
	    if ($read_allowed && $sent_byte == 0xFF) {
		printf "Read byte 0x%02x\n", $read_byte;
	    }
	    else {
		printf "Sent byte 0x%02x\n", $sent_byte;
	    }
	    $bit_count = $sent_byte = $read_byte = 0;
	}
	else {
	    $sent_byte = $sent_byte << 1;
	}
    }
}
















